

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter g01

   Declare Ptrsafe Sub g01adc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByRef x As double, _
    ByRef ifreq As long, _
    ByRef xmean As double, _
    ByRef xsd As double, _
    ByRef xskew As double, _
    ByRef xkurt As double, _
    ByRef n As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01aec Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal num_class As long, _
    ByVal classb As Nag_ClassBoundary, _
    ByRef dnint As double, _
    ByRef ifreq As long, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01alc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef res As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01amc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef rv As double, _
    ByVal nq As long, _
    ByRef q As double, _
    ByRef qv As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01anc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ind As long, _
    ByVal n As long, _
    ByRef rv As double, _
    ByVal nb As long, _
    ByVal eps As double, _
    ByRef np As long, _
    ByRef q As double, _
    ByRef qv As double, _
    ByVal nq As long, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01apc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ind As long, _
    ByRef rv As double, _
    ByVal nb As long, _
    ByVal eps As double, _
    ByRef np As long, _
    ByRef q As double, _
    ByRef qv As double, _
    ByVal nq As long, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01atc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nb As long, _
    ByRef x As double, _
    ByRef wt As double, _
    ByRef pn As long, _
    ByRef xmean As double, _
    ByRef xsd As double, _
    ByRef xskew As double, _
    ByRef xkurt As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01auc Lib "CLW6I26DE_nag.dll" ( _
    ByVal b As long, _
    ByRef mrcomm As double, _
    ByRef pn As long, _
    ByRef xmean As double, _
    ByRef xsd As double, _
    ByRef xskew As double, _
    ByRef xkurt As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01bjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal p As double, _
    ByVal k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01bkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal rlamda As double, _
    ByVal k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01blc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal l As long, _
    ByVal m As long, _
    ByVal k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef pp As double, _
    ByVal etol As double, _
    ByRef errest As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01dcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal exp1 As double, _
    ByVal exp2 As double, _
    ByVal sumssq As double, _
    ByRef vec As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01ddc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal calc_wts As Nag_Boolean, _
    ByRef a As double, _
    ByRef w As double, _
    ByRef pw As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01dhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal scores As Nag_Scores, _
    ByVal ties As Nag_Ties, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef r As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g01eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01ebc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal t As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01ecc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01edc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal f As double, _
    ByVal df1 As double, _
    ByVal df2 As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub g01eec Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal tol As double, _
    ByRef p As double, _
    ByRef q As double, _
    ByRef pdf As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g01efc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal g As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01emc Lib "CLW6I26DE_nag.dll" ( _
    ByVal q As double, _
    ByVal v As double, _
    ByVal ir As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub g01epc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByVal d As double, _
    ByRef pdl As double, _
    ByRef pdu As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g01erc Lib "CLW6I26DE_nag.dll" ( _
    ByVal t As double, _
    ByVal vk As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01etc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double _
   ) As double


   Declare Ptrsafe Function g01euc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByRef comm_arr As double _
   ) As double


   Declare Ptrsafe Function g01ewc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_TS_URProbMethod, _
    ByVal typ As Nag_TS_URTestType, _
    ByVal n As long, _
    ByVal ts As double, _
    ByVal nsamp As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01eyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal d As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01ezc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n1 As long, _
    ByVal n2 As long, _
    ByVal d As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01fac Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01fbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01fcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal p As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01fdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal p As double, _
    ByVal df1 As double, _
    ByVal df2 As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01fec Lib "CLW6I26DE_nag.dll" ( _
    ByVal p As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01ffc Lib "CLW6I26DE_nag.dll" ( _
    ByVal p As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01fmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal p As double, _
    ByVal v As double, _
    ByVal ir As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01ftc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01gbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal t As double, _
    ByVal df As double, _
    ByVal delta As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01gcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByVal df As double, _
    ByVal lambda As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01gdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As double, _
    ByVal df1 As double, _
    ByVal df2 As double, _
    ByVal lambda As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01gec Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal lambda As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01hac Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByVal y As double, _
    ByVal rho As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01hbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef mean As double, _
    ByRef sigma As double, _
    ByVal tdsig As long, _
    ByVal tol As double, _
    ByVal maxpts As long, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01hcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal df As long, _
    ByVal rho As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01hdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal tail As Nag_TailProbability, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal nu As double, _
    ByRef delta As double, _
    ByVal iscov As Nag_Boolean, _
    ByRef rc As double, _
    ByVal pdrc As long, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal numsub As long, _
    ByVal nsampl As long, _
    ByVal fmax As long, _
    ByRef errest As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub g01jcc Lib "CLW6I26DE_nag.dll" ( _
    ByRef a As double, _
    ByRef mult As long, _
    ByRef rlamda As double, _
    ByVal n As long, _
    ByVal c As double, _
    ByRef p As double, _
    ByRef pdf As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01jdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_LCCMethod, _
    ByVal n As long, _
    ByRef rlam As double, _
    ByVal d As double, _
    ByVal c As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g01kac Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByVal xmean As double, _
    ByVal xstd As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Function g01kfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub g01kkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByRef pdf As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01kqc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal lxmu As long, _
    ByRef xmu As double, _
    ByVal lxstd As long, _
    ByRef xstd As double, _
    ByRef pdf As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01lbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal k As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef xmu As double, _
    ByVal iuld As Nag_MatrixType, _
    ByRef sig As double, _
    ByVal pdsig As long, _
    ByRef pdf As double, _
    ByRef rank As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g01mbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double _
   ) As double


   Declare Ptrsafe Function g01mtc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double _
   ) As double


   Declare Ptrsafe Function g01muc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByRef comm_arr As double _
   ) As double


   Declare Ptrsafe Sub g01nac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mom As Nag_SelectMoments, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByRef emu As double, _
    ByRef sigma As double, _
    ByVal pdsig As long, _
    ByVal l As long, _
    ByRef rkum As double, _
    ByRef rmom As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01nbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ratio_type As Nag_MomentType, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef a As double, ByVal pda As long, ByRef b As double, _
    ByVal pdb As long, ByRef c As double, ByVal pdc As long, _
    ByRef ela As double, ByRef emu As double, ByRef sigma As double, _
    ByVal pdsig As long, ByVal l1 As long, ByVal l2 As long, _
    ByRef lmax As long, ByRef rmom As double, ByRef abserr As double, _
    ByVal eps As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Function g01ptc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double _
   ) As double


   Declare Ptrsafe Function g01qtc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double _
   ) As double


   Declare Ptrsafe Function g01rtc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double _
   ) As double


   Declare Ptrsafe Sub g01sac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal lxmu As long, _
    ByRef xmu As double, _
    ByVal lxstd As long, _
    ByRef xstd As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01sbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lt As long, _
    ByRef t As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01scc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01sdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lf As long, _
    ByRef f As double, _
    ByVal ldf1 As long, _
    ByRef df1 As double, _
    ByVal ldf2 As long, _
    ByRef df2 As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01sec Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lbeta As long, _
    ByRef beta As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01sfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lg As long, _
    ByRef g As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01sjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ln As long, _
    ByRef n As long, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal lk As long, _
    ByRef k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01skc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ll As long, _
    ByRef l As double, _
    ByVal lk As long, _
    ByRef k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01slc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ln As long, _
    ByRef n As long, _
    ByVal ll As long, _
    ByRef l As long, _
    ByVal lm As long, _
    ByRef m As long, _
    ByVal lk As long, _
    ByRef k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01tac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal lxmu As long, _
    ByRef xmu As double, _
    ByVal lxstd As long, _
    ByRef xstd As double, _
    ByRef x As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01tbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef t As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01tcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef x As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01tdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal ldf1 As long, _
    ByRef df1 As double, _
    ByVal ldf2 As long, _
    ByRef df2 As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01tec Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByVal tol As double, _
    ByRef beta As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01tfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByVal tol As double, _
    ByRef g As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01wac Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal nb As long, _
    ByRef x As double, _
    ByVal iwt As Nag_Weightstype, _
    ByRef wt As double, _
    ByRef pn As long, _
    ByRef rmean As double, _
    ByRef rsd As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g01zuc Lib "CLW6I26DE_nag.dll" ( _
    ByVal rkappa As double, _
    ByVal beta2 As double, _
    ByVal mode As long, _
    ByRef xl As double, _
    ByRef xu As double, _
    ByRef comm_arr As double, _
    ByRef fail As NagError _
   )


' chapter g02

   Declare Ptrsafe Sub g02aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal errtol As double, _
    ByVal maxits As long, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef feval As long, _
    ByRef nrmgrd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal opt As Nag_NearCorr_ProbType, _
    ByVal alpha As double, _
    ByRef w As double, _
    ByVal errtol As double, _
    ByVal maxits As long, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef feval As long, _
    ByRef nrmgrd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02aec Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal k As long, _
    ByVal errtol As double, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef feval As long, _
    ByRef nrmpgd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02ajc Lib "CLW6I26DE_nag.dll" ( _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal alpha As double, _
    ByRef h As double, _
    ByVal pdh As long, _
    ByVal errtol As double, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef norm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02anc Lib "CLW6I26DE_nag.dll" ( _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal k As long, _
    ByVal errtol As double, _
    ByVal eigtol As double, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef alpha As double, _
    ByRef iter As long, _
    ByRef eigmin As double, _
    ByRef norm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02apc Lib "CLW6I26DE_nag.dll" ( _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal theta As double, _
    ByRef h As double, _
    ByVal pdh As long, _
    ByVal errtol As double, _
    ByVal eigtol As double, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef alpha As double, _
    ByRef iter As long, _
    ByRef eigmin As double, _
    ByRef norm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02brc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef svar As long, _
    ByRef sobs As long, _
    ByRef corr As double, _
    ByVal tdc As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02btc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As long, _
    ByVal wt As double, _
    ByRef x As double, _
    ByVal incx As long, _
    ByRef sw As double, _
    ByRef xbar As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02buc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_SumSquare, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef wt As double, _
    ByRef sw As double, _
    ByRef wmean As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02bwc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef r As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02bxc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef sx As long, _
    ByRef wt As double, _
    ByRef sw As double, _
    ByRef wmean As double, _
    ByRef std As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02byc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal ny As long, _
    ByVal nx As long, _
    ByRef sz As long, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef p As double, _
    ByVal tdp As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02bzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As long, _
    ByRef xsw As double, _
    ByRef xmean As double, _
    ByRef xc As double, _
    ByVal ysw As double, _
    ByRef ymean As double, _
    ByRef yc As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef a_serr As double, _
    ByRef b_serr As double, _
    ByRef rsq As double, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02cbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByVal clm As double, _
    ByVal clp As double, _
    ByRef yhat As double, _
    ByRef yml As double, _
    ByRef ymu As double, _
    ByRef yl As double, _
    ByRef yu As double, _
    ByRef h As double, _
    ByRef res As double, _
    ByRef rms As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal mean As Nag_IncludeMean, ByVal n As long, ByRef x As double, _
    ByVal tdx As long, ByVal m As long, ByRef sx As long, _
    ByVal ip As long, ByRef y As double, ByRef wt As double, _
    ByRef rss As double, ByRef df As double, ByRef b As double, _
    ByRef se As double, ByRef cov As double, ByRef res As double, _
    ByRef h As double, ByRef q As double, ByVal tdq As long, _
    ByRef svd As Nag_Boolean, ByRef rank As long, ByRef p As double, _
    ByVal tol As double, ByRef com_ar As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal update As Nag_UpdateObserv, _
    ByVal mean As Nag_IncludeMean, _
    ByVal m As long, _
    ByRef sx As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByVal ip As long, _
    ByRef x As double, _
    ByVal nr As long, _
    ByVal tdx As long, _
    ByVal ix As long, _
    ByVal y As double, _
    ByRef wt As double, _
    ByRef rss As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02ddc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef b As double, _
    ByRef se As double, _
    ByRef cov As double, _
    ByRef svd As Nag_Boolean, _
    ByRef rank As long, _
    ByRef p As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dec Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByRef p As double, _
    ByRef wt As double, _
    ByRef x As double, _
    ByRef rss As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ip As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByVal indx As long, _
    ByRef rss As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef wt As double, _
    ByRef rss As double, _
    ByVal ip As long, _
    ByVal rank As long, _
    ByRef cov As double, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByVal svd As Nag_Boolean, _
    ByRef p As double, _
    ByRef y As double, _
    ByRef b As double, _
    ByRef se As double, _
    ByRef res As double, _
    ByRef com_ar As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ip As long, _
    ByVal iconst As long, _
    ByRef p As double, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef b As double, _
    ByVal rss As double, _
    ByVal df As double, _
    ByRef se As double, _
    ByRef cov As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02dnc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ip As long, _
    ByVal rank As long, _
    ByRef b As double, _
    ByRef cov As double, _
    ByRef p As double, _
    ByRef f As double, _
    ByRef est As Nag_Boolean, _
    ByRef stat As double, _
    ByRef sestat As double, _
    ByRef t As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef var_names As longPtr, _
    ByRef sx As long, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef nmod As long, _
    ByRef model As longPtr, _
    ByRef rss As double, _
    ByRef nterms As long, _
    ByRef mrank As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02ecc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As long, _
    ByVal sigsq As double, _
    ByVal tss As double, _
    ByVal nmod As long, _
    ByRef nterms As long, _
    ByRef rss As double, _
    ByRef rsq As double, _
    ByRef cp As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02eec Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef istep As long, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByVal m As long, ByRef x As double, ByVal pdx As long, _
    ByRef var_names As longPtr, ByRef sx As long, ByVal maxip As long, _
    ByRef y As double, ByRef wt As double, ByVal fin As double, _
    ByRef addvar As Nag_Boolean, ByRef newvar As longPtr, ByRef chrss As double, _
    ByRef f As double, ByRef model As longPtr, ByRef nterm As long, _
    ByRef rss As double, ByRef idf As long, ByRef ifr As long, _
    ByRef free_vars As longPtr, ByRef exss As double, ByRef q As double, _
    ByVal pdq As long, ByRef p As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub G02EFH Lib "CLW6I26DE_nag.dll" ( _
    ByVal flag As Nag_FullStepwise, _
    ByVal var As long, _
    ByVal val As double, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub g02efc_monfun( _
'      ByVal flag As Nag_FullStepwise, _
'      ByVal var As long, _
'      ByVal val As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub g02efc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef wmean As double, _
    ByRef c As double, _
    ByVal sw As double, _
    ByRef isx As long, _
    ByVal fin As double, _
    ByVal fout As double, _
    ByVal tau As double, _
    ByRef b As double, _
    ByRef se As double, _
    ByRef rsq As double, _
    ByRef rms As double, _
    ByRef df As long, _
    ByVal monfun As longPtr, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02fac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByVal nres As long, _
    ByRef res As double, _
    ByRef h As double, _
    ByVal rms As double, _
    ByRef sres As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02fcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal p As long, _
    ByRef res As double, _
    ByRef d As double, _
    ByRef pdl As double, _
    ByRef pdu As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gac Lib "CLW6I26DE_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef wt As double, ByRef offset As double, ByRef dnscale As double, _
    ByVal ex_power As double, ByRef rss As double, ByRef df As double, _
    ByRef b As double, ByRef rank As long, ByRef se As double, _
    ByRef cov As double, ByRef v As double, ByVal tdv As long, _
    ByVal tol As double, ByVal max_iter As long, ByVal print_iter As long, _
    ByVal outfile As String, ByVal eps As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef binom_t As double, ByRef wt As double, ByRef offset As double, _
    ByRef dev As double, ByRef df As double, ByRef b As double, _
    ByRef rank As long, ByRef se As double, ByRef cov As double, _
    ByRef v As double, ByVal tdv As long, ByVal tol As double, _
    ByVal max_iter As long, ByVal print_iter As long, ByVal outfile As String, _
    ByVal eps As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef wt As double, ByRef offset As double, ByVal ex_power As double, _
    ByRef dev As double, ByRef df As double, ByRef b As double, _
    ByRef rank As long, ByRef se As double, ByRef cov As double, _
    ByRef v As double, ByVal tdv As long, ByVal tol As double, _
    ByVal max_iter As long, ByVal print_iter As long, ByVal outfile As String, _
    ByVal eps As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef wt As double, ByRef offset As double, ByRef dnscale As double, _
    ByVal ex_power As double, ByRef dev As double, ByRef df As double, _
    ByRef b As double, ByRef rank As long, ByRef se As double, _
    ByRef cov As double, ByRef v As double, ByVal tdv As long, _
    ByVal tol As double, ByVal max_iter As long, ByVal print_iter As long, _
    ByVal outfile As String, ByVal eps As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ip As long, _
    ByVal nclin As long, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef b As double, _
    ByVal dnscale As double, _
    ByRef se As double, _
    ByRef cov As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gnc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ip As long, _
    ByVal rank As long, _
    ByRef b As double, _
    ByRef cov As double, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef f As double, _
    ByRef est As Nag_Boolean, _
    ByRef stat As double, _
    ByRef sestat As double, _
    ByRef z As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02gpc Lib "CLW6I26DE_nag.dll" ( _
    ByVal errfn As Nag_Distributions, ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, _
    ByVal n As long, ByRef x As double, ByVal tdx As long, _
    ByVal m As long, ByRef sx As long, ByVal ip As long, _
    ByRef binom_t As double, ByRef offset As double, ByRef wt As double, _
    ByVal dnscale As double, ByVal ex_power As double, ByRef b As double, _
    ByRef cov As double, ByVal vfobs As Nag_Boolean, ByRef eta As double, _
    ByRef seeta As double, ByRef pred As double, ByRef sepred As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02hac Lib "CLW6I26DE_nag.dll" ( _
    ByVal regtype As Nag_RegType, ByVal psifun As Nag_PsiFun, ByVal sigma_est As Nag_SigmaEst, _
    ByVal covmat_est As Nag_CovMatrixEst, ByVal n As long, ByVal m As long, _
    ByRef x As double, ByVal tdx As long, ByRef y As double, _
    ByVal cpsi As double, ByRef hpsi As double, ByVal cucv As double, _
    ByVal dchi As double, ByRef theta As double, ByRef sigma As double, _
    ByRef c As double, ByVal tdc As long, ByRef rs As double, _
    ByRef wt As double, ByVal tol As double, ByVal max_iter As long, _
    ByVal print_iter As long, ByVal outfile As String, ByRef info As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function g02hbc_ucv( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub g02hbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As longPtr, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef a As double, _
    ByRef z As double, _
    ByVal bl As double, _
    ByVal bd As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByVal nitmon As long, _
    ByVal outfile As String, _
    ByRef nit As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function G02HDZ Lib "CLW6I26DE_nag.dll" ( _
    ByVal t As double, _
    ByRef comm As Nag_Comm _
  ) As double

' skeleton code for callback function
'  Function g02hdc_chi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function


' skeleton code for callback function
'  Function g02hdc_psi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub g02hdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal chi As longPtr, _
    ByVal psi As longPtr, _
    ByVal psip0 As double, _
    ByVal beta As double, ByVal regtype As Nag_RegType, ByVal sigma_est As Nag_SigmaEst, _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef y As double, ByRef wgt As double, _
    ByRef theta As double, ByRef k As long, ByRef sigma As double, _
    ByRef rs As double, ByVal tol As double, ByVal eps As double, _
    ByVal maxit As long, ByVal nitmon As long, ByVal outfile As String, _
    ByRef nit As long, ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function g02hfc_psi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function g02hfc_psp( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub g02hfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal psi As longPtr, _
    ByVal psp As longPtr, _
    ByVal regtype As Nag_RegType, _
    ByVal covmat_est As Nag_CovMatrixEst, _
    ByVal sigma As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef rs As double, _
    ByRef wgt As double, _
    ByRef cov As double, _
    ByVal pdc As long, _
    ByRef comm_arr As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02hkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByVal eps As double, _
    ByRef cov As double, _
    ByRef theta As double, _
    ByVal max_iter As long, _
    ByVal print_iter As long, _
    ByVal outfile As String, _
    ByVal tol As double, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g02hlc_ucv( _
'      ByVal t As double, _
'      ByRef u As double, _
'      ByRef ud As double, _
'      ByRef w As double, _
'      ByRef wd As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g02hlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As longPtr, _
    ByVal indm As long, ByVal n As long, _
    ByVal m As long, ByRef x As double, ByVal pdx As long, _
    ByRef cov As double, ByRef a As double, ByRef wt As double, _
    ByRef theta As double, ByVal bl As double, ByVal bd As double, _
    ByVal maxit As long, ByVal nitmon As long, ByVal outfile As String, _
    ByVal tol As double, ByRef nit As long, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g02hmc_ucv( _
'      ByVal t As double, _
'      ByRef u As double, _
'      ByRef w As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g02hmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As longPtr, _
    ByVal indm As long, ByVal n As long, _
    ByVal m As long, ByRef x As double, ByVal pdx As long, _
    ByRef cov As double, ByRef a As double, ByRef wt As double, _
    ByRef theta As double, ByVal bl As double, ByVal bd As double, _
    ByVal maxit As long, ByVal nitmon As long, ByVal outfile As String, _
    ByVal tol As double, ByRef nit As long, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02jac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal ncol As long, ByRef dat As double, _
    ByVal tddat As long, ByRef levels As long, ByVal yvid As long, _
    ByVal cwid As long, ByVal nfv As long, ByRef fvid As long, _
    ByVal fint As long, ByVal nrv As long, ByRef rvid As long, _
    ByVal nvpr As long, ByRef vpr As long, ByVal rint As long, _
    ByVal svid As long, ByRef gamma As double, ByRef nff As long, _
    ByRef nrf As long, ByRef df As long, ByRef reml As double, _
    ByVal lb As long, ByRef b As double, ByRef se As double, _
    ByVal maxit As long, ByVal tol As double, ByRef warn As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02jbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal ncol As long, ByRef dat As double, _
    ByVal tddat As long, ByRef levels As long, ByVal yvid As long, _
    ByVal cwid As long, ByVal nfv As long, ByRef fvid As long, _
    ByVal fint As long, ByVal nrv As long, ByRef rvid As long, _
    ByVal nvpr As long, ByRef vpr As long, ByVal rint As long, _
    ByVal svid As long, ByRef gamma As double, ByRef nff As long, _
    ByRef nrf As long, ByRef df As long, ByRef ml As double, _
    ByVal lb As long, ByRef b As double, ByRef se As double, _
    ByVal maxit As long, ByVal tol As double, ByRef warn As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02jcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal ncol As long, ByRef dat As double, _
    ByVal pddat As long, ByRef levels As long, ByRef y As double, _
    ByRef wt As double, ByRef dnfixed As long, ByVal lfixed As long, _
    ByVal nrndm As long, ByRef rndm As long, ByVal lrndm As long, _
    ByRef nff As long, ByRef nlsv As long, ByRef nrf As long, _
    ByRef rcomm As double, ByVal lrcomm As long, ByRef icomm As long, _
    ByVal licomm As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02jdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal lvpr As long, ByRef vpr As long, ByVal nvpr As long, _
    ByRef gamma As double, ByRef effn As long, ByRef rnkx As long, _
    ByRef ncov As long, ByRef lnlike As double, ByVal lb As long, _
    ByRef id As long, ByVal pdid As long, ByRef b As double, _
    ByRef se As double, ByRef czz As double, ByVal pdczz As long, _
    ByRef cxx As double, ByVal pdcxx As long, ByRef cxz As double, _
    ByVal pdcxz As long, ByRef rcomm As double, ByRef icomm As long, _
    ByRef iopt As long, ByVal liopt As long, ByRef ropt As double, _
    ByVal lropt As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02jec Lib "CLW6I26DE_nag.dll" ( _
    ByVal lvpr As long, ByRef vpr As long, ByVal nvpr As long, _
    ByRef gamma As double, ByRef effn As long, ByRef rnkx As long, _
    ByRef ncov As long, ByRef lnlike As double, ByVal lb As long, _
    ByRef id As long, ByVal pdid As long, ByRef b As double, _
    ByRef se As double, ByRef czz As double, ByVal pdczz As long, _
    ByRef cxx As double, ByVal pdcxx As long, ByRef cxz As double, _
    ByVal pdcxz As long, ByRef rcomm As double, ByRef icomm As long, _
    ByRef iopt As long, ByVal liopt As long, ByRef ropt As double, _
    ByVal lropt As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02kac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByVal tau As double, ByRef y As double, ByRef h As double, _
    ByVal opt As Nag_PredictError, ByRef niter As long, ByVal tol As double, _
    ByRef nep As double, ByVal orig As Nag_EstimatesOption, ByRef b As double, _
    ByRef vif As double, ByRef res As double, ByRef rss As double, _
    ByRef df As long, ByVal optloo As Nag_OptionLOO, ByRef perr As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02kbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByRef y As double, ByVal lh As long, ByRef h As double, _
    ByRef nep As double, ByVal wantb As Nag_ParaOption, ByRef b As double, _
    ByVal pdb As long, ByVal wantvf As Nag_VIFOption, ByRef vf As double, _
    ByVal pdvf As long, ByVal lpec As long, ByVal pec As Nag_PredictError, _
    ByRef pe As double, ByVal pdpe As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02lac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal mx As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByVal my As long, ByRef y As double, ByVal pdy As long, _
    ByRef xbar As double, ByRef ybar As double, ByVal iscale As Nag_ScalePredictor, _
    ByRef xstd As double, ByRef ystd As double, ByVal maxfac As long, _
    ByRef xres As double, ByVal pdxres As long, ByRef yres As double, _
    ByVal pdyres As long, ByRef w As double, ByVal pdw As long, _
    ByRef p As double, ByVal pdp As long, ByRef t As double, _
    ByVal pdt As long, ByRef c As double, ByVal pdc As long, _
    ByRef u As double, ByVal pdu As long, ByRef xcv As double, _
    ByRef ycv As double, ByVal pdycv As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02lbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal mx As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByVal my As long, ByRef y As double, ByVal pdy As long, _
    ByRef xbar As double, ByRef ybar As double, ByVal iscale As Nag_ScalePredictor, _
    ByRef xstd As double, ByRef ystd As double, ByVal maxfac As long, _
    ByVal maxit As long, ByVal tau As double, ByRef xres As double, _
    ByVal pdxres As long, ByRef yres As double, ByVal pdyres As long, _
    ByRef w As double, ByVal pdw As long, ByRef p As double, _
    ByVal pdp As long, ByRef t As double, ByVal pdt As long, _
    ByRef c As double, ByVal pdc As long, ByRef u As double, _
    ByVal pdu As long, ByRef xcv As double, ByRef ycv As double, _
    ByVal pdycv As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02lcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As long, ByVal my As long, ByVal maxfac As long, _
    ByVal nfact As long, ByRef p As double, ByVal pdp As long, _
    ByRef c As double, ByVal pdc As long, ByRef w As double, _
    ByVal pdw As long, ByVal rcond As double, ByRef b As double, _
    ByVal pdb As long, ByVal orig As Nag_EstimatesOption, ByRef xbar As double, _
    ByRef ybar As double, ByVal iscale As Nag_ScalePredictor, ByRef xstd As double, _
    ByRef ystd As double, ByRef ob As double, ByVal pdob As long, _
    ByVal vipopt As long, ByRef ycv As double, ByVal pdycv As long, _
    ByRef vip As double, ByVal pdvip As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02ldc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As long, _
    ByVal my As long, _
    ByVal orig As Nag_EstimatesOption, _
    ByRef xbar As double, _
    ByRef ybar As double, _
    ByVal iscale As Nag_ScalePredictor, _
    ByRef xstd As double, _
    ByRef ystd As double, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByVal n As long, _
    ByVal mz As long, _
    ByRef isz As long, _
    ByRef z As double, _
    ByVal pdz As long, _
    ByRef yhat As double, _
    ByVal pdyhat As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02mac Lib "CLW6I26DE_nag.dll" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal prey As Nag_LARSPreProcess, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef d As double, _
    ByVal pdd As long, _
    ByRef isx As long, _
    ByRef y As double, _
    ByVal mnstep As long, _
    ByRef ip As long, _
    ByRef nstep As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef fitsum As double, _
    ByRef ropt As double, _
    ByVal lropt As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02mbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal intcpt As Nag_LARSPreProcess, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef dtd As double, _
    ByVal pddtd As long, _
    ByRef isx As long, _
    ByRef dty As double, _
    ByVal yty As double, _
    ByVal mnstep As long, _
    ByRef ip As long, _
    ByRef nstep As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef fitsum As double, _
    ByRef ropt As double, _
    ByVal lropt As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02mcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nstep As long, _
    ByVal ip As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef fitsum As double, _
    ByVal ktype As Nag_LARSTargetType, _
    ByRef nk As double, _
    ByVal lnk As long, _
    ByRef nb As double, _
    ByVal pdnb As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02qfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal ntau As long, _
    ByRef tau As double, _
    ByRef df As double, _
    ByRef b As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef info As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02qgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal intcpt As Nag_IncludeIntercept, ByVal n As long, ByVal m As long, _
    ByRef dat As double, ByVal pddat As long, ByRef isx As long, _
    ByVal ip As long, ByRef y As double, ByRef wt As double, _
    ByVal ntau As long, ByRef tau As double, ByRef df As double, _
    ByRef b As double, ByRef bl As double, ByRef bu As double, _
    ByRef ch As double, ByRef res As double, ByRef iopts As long, _
    ByRef opts As double, ByRef state As long, ByRef info As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02zkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g02zlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' chapter g03

   Declare Ptrsafe Sub g03aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal pcmatrix As Nag_PrinCompMat, _
    ByVal scores As Nag_PrinCompScores, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByRef s As double, _
    ByRef wt As double, _
    ByVal nvar As long, _
    ByRef e As double, _
    ByVal tde As long, _
    ByRef p As double, _
    ByVal tdp As long, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03acc Lib "CLW6I26DE_nag.dll" ( _
    ByVal weight As Nag_Weightstype, ByVal n As long, ByVal m As long, _
    ByRef x As double, ByVal tdx As long, ByRef isx As long, _
    ByVal nx As long, ByRef ing As long, ByVal ng As long, _
    ByRef wt As double, ByRef nig As long, ByRef cvm As double, _
    ByVal tdcvm As long, ByRef e As double, ByVal tde As long, _
    ByRef ncv As long, ByRef cvx As double, ByVal tdcvx As long, _
    ByVal tol As double, ByRef irankx As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03adc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef z As double, _
    ByVal tdz As long, _
    ByRef isz As long, _
    ByVal nx As long, _
    ByVal ny As long, _
    ByRef wt As double, _
    ByRef e As double, _
    ByVal tde As long, _
    ByRef ncv As long, _
    ByRef cvx As double, _
    ByVal tdcvx As long, _
    ByRef cvy As double, _
    ByVal tdcvy As long, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal g As double, _
    ByVal nvar As long, _
    ByVal k As long, _
    ByRef fl As double, _
    ByVal tdf As long, _
    ByRef flr As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByVal acc As double, _
    ByVal maxit As long, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03bcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal stand As Nag_TransNorm, _
    ByVal pscale As Nag_RotationScale, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef y As double, _
    ByVal tdy As long, _
    ByRef yhat As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef alpha As double, _
    ByRef rss As double, _
    ByRef res As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03bdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef ro As double, _
    ByVal pdro As long, _
    ByVal power As double, _
    ByRef fp As double, _
    ByVal pdfp As long, _
    ByRef r As double, _
    ByVal pdr As long, _
    ByRef phi As double, _
    ByVal pdphi As long, _
    ByRef fs As double, _
    ByVal pdfs As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal matrix As Nag_FacMat, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByVal nvar As long, _
    ByRef isx As long, _
    ByVal nfac As long, _
    ByRef wt As double, _
    ByRef e As double, _
    ByRef stat As double, _
    ByRef com As double, _
    ByRef psi As double, _
    ByRef res As double, _
    ByRef fl As double, _
    ByVal tdfl As long, _
    ByRef ops As Nag_E04_Opt, _
    ByVal eps As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03ccc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_FacScoreMethod, _
    ByVal rotate As Nag_FacRotation, _
    ByVal nvar As long, _
    ByVal nfac As long, _
    ByRef fl As double, _
    ByVal tdfl As long, _
    ByRef psi As double, _
    ByRef e As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef fs As double, _
    ByVal tdfs As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByVal nvar As long, _
    ByRef ing As long, _
    ByVal ng As long, _
    ByRef wt As double, _
    ByRef nig As long, _
    ByRef gmean As double, _
    ByVal tdg As long, _
    ByRef det As double, _
    ByRef gc As double, _
    ByRef stat As double, _
    ByRef df As double, _
    ByRef sig As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03dbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal equal As Nag_GroupCovars, _
    ByVal mode As Nag_MahalDist, _
    ByVal nvar As long, _
    ByVal ng As long, _
    ByRef gmean As double, _
    ByVal tdg As long, _
    ByRef gc As double, _
    ByVal nobs As long, _
    ByVal m As long, _
    ByRef isx As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef d As double, _
    ByVal tdd As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03dcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal typ As Nag_DiscrimMethod, ByVal equal As Nag_GroupCovars, ByVal priors As Nag_PriorProbability, _
    ByVal nvar As long, ByVal ng As long, ByRef nig As long, _
    ByRef gmean As double, ByVal tdg As long, ByRef gc As double, _
    ByRef det As double, ByVal nobs As long, ByVal m As long, _
    ByRef isx As long, ByRef x As double, ByVal tdx As long, _
    ByRef prior As double, ByRef p As double, ByVal tdp As long, _
    ByRef iag As long, ByVal atiq As Nag_Boolean, ByRef ati As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal update As Nag_MatUpdate, _
    ByVal dist As Nag_DistanceType, _
    ByVal dnscale As Nag_VarScaleType, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByRef s As double, _
    ByRef d As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03ecc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_ClusterMethod, _
    ByVal n As long, _
    ByRef d As double, _
    ByRef ilc As long, _
    ByRef iuc As long, _
    ByRef cd As double, _
    ByRef iord As long, _
    ByRef dord As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03efc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByVal nvar As long, _
    ByVal k As long, _
    ByRef cmeans As double, _
    ByVal tdc As long, _
    ByRef wt As double, _
    ByRef inc As long, _
    ByRef nic As long, _
    ByRef css As double, _
    ByRef csw As double, _
    ByVal maxit As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03ehc Lib "CLW6I26DE_nag.dll" ( _
    ByVal orient As Nag_DendOrient, _
    ByVal n As long, _
    ByRef dord As double, _
    ByVal dmin As double, _
    ByVal dstep As double, _
    ByVal nsym As long, _
    ByVal c As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03ejc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef cd As double, _
    ByRef iord As long, _
    ByRef dord As double, _
    ByRef k As long, _
    ByRef dlevel As double, _
    ByRef ic As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03fac Lib "CLW6I26DE_nag.dll" ( _
    ByVal roots As Nag_Eigenvalues, _
    ByVal n As long, _
    ByRef d As double, _
    ByVal ndim As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef eval As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03fcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal typ As Nag_ScaleCriterion, _
    ByVal n As long, _
    ByVal ndim As long, _
    ByRef d As double, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef stress As double, _
    ByRef dfit As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03gac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal nvar As long, _
    ByVal ng As long, ByVal popt As Nag_Boolean, ByRef prob As double, _
    ByVal tdprob As long, ByRef niter As long, ByVal riter As long, _
    ByRef w As double, ByRef g As double, ByVal sopt As Nag_VarCovar, _
    ByRef s As double, ByRef f As double, ByVal tol As double, _
    ByRef loglik As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g03xzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal c As String _
   )


   Declare Ptrsafe Sub g03zac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByVal nvar As long, _
    ByRef isx As long, _
    ByRef s As double, _
    ByRef e As double, _
    ByRef z As double, _
    ByVal tdz As long, _
    ByRef fail As NagError _
   )


' chapter g04

   Declare Ptrsafe Sub g04bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef y As double, _
    ByVal blocks As Nag_Blocks, _
    ByVal iblock As long, _
    ByVal nt As long, _
    ByRef it As long, _
    ByRef gmean As double, _
    ByRef bmean As double, _
    ByRef tmean As double, _
    ByRef table As double, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef irep As long, _
    ByRef r As double, _
    ByRef ef As double, _
    ByVal tol As double, _
    ByVal irdf As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g04bcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nrep As long, ByVal nrow As long, ByVal ncol As long, _
    ByRef y As double, ByVal nt As long, ByRef it As long, _
    ByRef gmean As double, ByRef tmean As double, ByRef table As double, _
    ByRef c As double, ByVal tdc As long, ByRef irep As long, _
    ByRef rpmean As double, ByRef rmean As double, ByRef cmean As double, _
    ByRef r As double, ByRef ef As double, ByVal tol As double, _
    ByVal irdf As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g04cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef y As double, _
    ByVal nfac As long, _
    ByRef lfac As long, _
    ByVal nblock As long, _
    ByVal inter As long, _
    ByVal irdf As long, _
    ByRef mterm As long, _
    ByRef tableptr As longPtr, _
    ByRef tmeanptr As longPtr, _
    ByRef maxt As long, _
    ByRef eptr As longPtr, _
    ByRef imeanptr As longPtr, _
    ByRef semeanptr As longPtr, _
    ByRef bmeanptr As longPtr, _
    ByRef r As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g04czc Lib "CLW6I26DE_nag.dll" ( _
    ByRef tableptr As longPtr, _
    ByRef tmeanptr As longPtr, _
    ByRef eptr As longPtr, _
    ByRef imeanptr As longPtr, _
    ByRef semeanptr As longPtr, _
    ByRef bmeanptr As longPtr _
   )


   Declare Ptrsafe Sub g04dbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal typ As Nag_IntervalType, _
    ByVal nt As long, _
    ByRef tmean As double, _
    ByVal rdf As double, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByVal clevel As double, _
    ByRef cil As double, _
    ByRef ciu As double, _
    ByRef isig As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g04eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal typ As Nag_DummyType, _
    ByVal n As long, _
    ByVal levels As long, _
    ByRef factor As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef v As double, _
    ByRef num_reps As double, _
    ByRef fail As NagError _
   )


' chapter g05

   Declare Ptrsafe Sub g05kfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As long, _
    ByRef seed As long, _
    ByVal lseed As long, _
    ByRef state As long, _
    ByRef lstate As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05kgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As long, _
    ByRef state As long, _
    ByRef lstate As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05khc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal k As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05kjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05kkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ncc Lib "CLW6I26DE_nag.dll" ( _
    ByRef indx As long, _
    ByVal n As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ndc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ipop As long, _
    ByVal n As long, _
    ByRef isampl As long, _
    ByVal m As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05nec Lib "CLW6I26DE_nag.dll" ( _
    ByVal sortorder As Nag_SortOrder, _
    ByRef wt As double, _
    ByRef ipop As long, _
    ByVal n As long, _
    ByRef isampl As long, _
    ByVal m As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pec Lib "CLW6I26DE_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05phc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal xmean As double, _
    ByVal ip As long, _
    ByRef phi As double, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal avar As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef var As double, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal k As long, _
    ByRef xmean As double, _
    ByVal p As long, _
    ByRef phi As double, _
    ByVal q As long, _
    ByRef theta As double, _
    ByRef var As double, _
    ByVal pdv As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal n As long, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As long, _
    ByRef param As double, _
    ByRef init As double, _
    ByVal var As double, _
    ByRef r As double, _
    ByRef state As long, _
    ByRef e As double, _
    ByVal en As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pvc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal fold As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal sordx As Nag_DataByObsOrVar, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef nt As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pwc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nt As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal sordx As Nag_DataByObsOrVar, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pxc Lib "CLW6I26DE_nag.dll" ( _
    ByVal side As Nag_SideType, _
    ByVal init As Nag_InitializeA, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef state As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef d As double, _
    ByVal eps As double, _
    ByRef state As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05pzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal nrow As long, _
    ByVal ncol As long, _
    ByRef totr As long, _
    ByRef totc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal df As long, _
    ByVal m As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rec Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ryc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal df As long, _
    ByVal m As long, _
    ByRef xmu As double, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05rzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef xmu As double, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05scc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmed As double, _
    ByVal semiqr As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal df As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sec Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef a As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal nmix As long, _
    ByRef a As double, _
    ByRef wgt As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05shc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal df1 As long, _
    ByVal df2 As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05skc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmu As double, _
    ByVal var As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05slc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05smc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmu As double, _
    ByVal var As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05snc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal df As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05spc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmed As double, _
    ByVal xmax As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05sqc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05src Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal vk As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ssc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tac Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal p As double, _
    ByRef state As long, _
    ByRef x As Nag_Boolean, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByRef p As double, _
    ByVal np As long, _
    ByVal ip1 As long, _
    ByVal itype As Nag_DiscreteDistrib, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tec Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal ns As long, _
    ByVal np As long, _
    ByVal m As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal a As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal k As long, _
    ByRef p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05thc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal lambda As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef vlamda As double, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05tlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As long, _
    ByVal b As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05xac Lib "CLW6I26DE_nag.dll" ( _
    ByVal t0 As double, _
    ByVal tend As double, _
    ByRef times As double, _
    ByVal ntimes As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05xbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As long, _
    ByVal d As long, _
    ByRef start As double, _
    ByVal a As long, _
    ByRef term As double, _
    ByRef z As double, _
    ByVal pdz As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05xcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal t0 As double, _
    ByVal tend As double, _
    ByRef times As double, _
    ByVal ntimes As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05xdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As long, _
    ByVal d As long, _
    ByVal a As long, _
    ByRef diff As double, _
    ByRef z As double, _
    ByVal pdz As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05xec Lib "CLW6I26DE_nag.dll" ( _
    ByVal bgord As Nag_BridgeOrder, _
    ByVal t0 As double, _
    ByVal tend As double, _
    ByVal ntimes As long, _
    ByRef intime As double, _
    ByVal nmove As long, _
    ByRef move As long, _
    ByRef times As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05yjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef xmean As double, _
    ByRef std As double, _
    ByVal n As long, _
    ByRef quas As double, _
    ByVal pdquas As long, _
    ByRef iref As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ykc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef xmean As double, _
    ByRef std As double, _
    ByVal n As long, _
    ByRef quas As double, _
    ByVal pdquas As long, _
    ByRef iref As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ylc Lib "CLW6I26DE_nag.dll" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal idim As long, _
    ByRef iref As long, _
    ByVal liref As long, _
    ByVal iskip As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ymc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, _
    ByRef quas As double, _
    ByVal pdquas As long, _
    ByRef iref As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ync Lib "CLW6I26DE_nag.dll" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal stype As Nag_QuasiRandom_Scrambling, _
    ByVal idim As long, _
    ByRef iref As long, _
    ByVal liref As long, _
    ByVal iskip As long, _
    ByVal nsdigi As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g05zmc_cov1( _
'      ByVal x As double, _
'      ByRef gamma As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g05zmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ns As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByVal maxm As long, _
    ByVal var As double, _
    ByVal cov1 As longPtr, _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    ByRef lam As double, _
    ByRef xx As double, _
    ByRef m As long, _
    ByRef approx As long, _
    ByRef rho As double, _
    ByRef icount As long, _
    ByRef eig As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05znc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ns As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByVal maxm As long, _
    ByVal var As double, _
    ByVal cov As Nag_Variogram, _
    ByVal np As long, _
    ByRef prams As double, _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    ByRef lam As double, _
    ByRef xx As double, _
    ByRef m As long, _
    ByRef approx As long, _
    ByRef rho As double, _
    ByRef icount As long, _
    ByRef eig As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05zpc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ns As long, _
    ByVal s As long, _
    ByVal m As long, _
    ByRef lam As double, _
    ByVal rho As double, _
    ByRef state As long, _
    ByRef z As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g05zqc_cov2( _
'      ByVal x As double, _
'      ByVal y As double, _
'      ByRef gamma As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g05zqc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ns As long, ByVal xmin As double, ByVal xmax As double, _
    ByVal ymin As double, ByVal ymax As double, ByRef maxm As long, _
    ByVal var As double, ByVal cov2 As longPtr, _
    ByVal parity As Nag_Parity, _
    ByVal pad As Nag_EmbedPad, ByVal corr As Nag_EmbedScale, ByRef lam As double, _
    ByRef xx As double, ByRef yy As double, ByRef m As long, _
    ByRef approx As long, ByRef rho As double, ByRef icount As long, _
    ByRef eig As double, ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05zrc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ns As long, ByVal xmin As double, ByVal xmax As double, _
    ByVal ymin As double, ByVal ymax As double, ByRef maxm As long, _
    ByVal var As double, ByVal cov As Nag_Variogram, ByVal norm As Nag_NormType, _
    ByVal np As long, ByRef prams As double, ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, ByRef lam As double, ByRef xx As double, _
    ByRef yy As double, ByRef m As long, ByRef approx As long, _
    ByRef rho As double, ByRef icount As long, ByRef eig As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05zsc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ns As long, _
    ByVal s As long, _
    ByRef m As long, _
    ByRef lam As double, _
    ByVal rho As double, _
    ByRef state As long, _
    ByRef z As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g05ztc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ns As long, _
    ByVal s As long, _
    ByVal m As long, _
    ByVal xmax As double, _
    ByVal h As double, _
    ByRef lam As double, _
    ByVal rho As double, _
    ByRef state As long, _
    ByRef z As double, _
    ByRef xx As double, _
    ByRef fail As NagError _
   )


' chapter g07

   Declare Ptrsafe Sub g07aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal k As long, _
    ByVal clevel As double, _
    ByRef pl As double, _
    ByRef pu As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmean As double, _
    ByVal clevel As double, _
    ByRef tl As double, _
    ByRef tu As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_CEMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef xc As double, _
    ByRef ic As long, _
    ByRef xmu As double, _
    ByRef xsig As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByRef sexmu As double, _
    ByRef sexsig As double, _
    ByRef corr As double, _
    ByRef dev As double, _
    ByRef nobs As long, _
    ByRef nit As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07bec Lib "CLW6I26DE_nag.dll" ( _
    ByVal cens As Nag_CestMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef ic As long, _
    ByRef beta As double, _
    ByRef gamma As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByRef sebeta As double, _
    ByRef segam As double, _
    ByRef corr As double, _
    ByRef dev As double, _
    ByRef nit As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07bfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef y As double, _
    ByVal optopt As Nag_OptimOpt, _
    ByRef xi As double, _
    ByRef beta As double, _
    ByRef asvc As double, _
    ByRef obsvc As double, _
    ByRef ll As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal equal As Nag_PopVar, _
    ByVal nx As long, _
    ByVal ny As long, _
    ByVal xmean As double, _
    ByVal ymean As double, _
    ByVal xstd As double, _
    ByVal ystd As double, _
    ByVal clevel As double, _
    ByRef t As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef dl As double, _
    ByRef du As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef xme As double, _
    ByRef xmd As double, _
    ByRef xsd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07dbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal sigma_est As Nag_SigmaSimulEst, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal psifun As Nag_PsiFun, _
    ByVal c As double, _
    ByVal h1 As double, _
    ByVal h2 As double, _
    ByVal h3 As double, _
    ByVal dchi As double, _
    ByRef theta As double, _
    ByRef sigma As double, _
    ByVal maxit As long, _
    ByVal tol As double, _
    ByRef rs As double, _
    ByRef nit As long, _
    ByRef sorted_x As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function g07dcc_chi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function g07dcc_psi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub g07dcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal chi As longPtr, _
    ByVal psi As longPtr, _
    ByVal isigma As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal beta As double, _
    ByRef theta As double, _
    ByRef sigma As double, _
    ByVal maxit As long, _
    ByVal tol As double, _
    ByRef rs As double, _
    ByRef nit As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07ddc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal alpha As double, _
    ByRef tmean As double, _
    ByRef wmean As double, _
    ByRef tvar As double, _
    ByRef wvar As double, _
    ByRef k As long, _
    ByRef sx As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal clevel As double, _
    ByRef theta As double, _
    ByRef thetal As double, _
    ByRef thetau As double, _
    ByRef estcl As double, _
    ByRef wlower As double, _
    ByRef wupper As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07ebc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal m As long, _
    ByRef y As double, _
    ByVal clevel As double, _
    ByRef theta As double, _
    ByRef thetal As double, _
    ByRef thetau As double, _
    ByRef estcl As double, _
    ByRef ulower As double, _
    ByRef uupper As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g07gac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal p As long, _
    ByRef y As double, _
    ByVal mean As double, _
    ByVal var As double, _
    ByRef iout As long, _
    ByRef niout As long, _
    ByVal ldiff As long, _
    ByRef diff As double, _
    ByRef llamb As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g07gbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal e As double, _
    ByVal var1 As double, _
    ByVal var2 As double, _
    ByRef x As double, _
    ByRef lx As double, _
    ByRef ux As double, _
    ByRef fail As NagError _
   ) As long


' chapter g08

   Declare Ptrsafe Sub g08aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef s As long, _
    ByRef p As double, _
    ByRef non_tied As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08acc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n1 As long, _
    ByRef x As double, _
    ByVal n2 As long, _
    ByRef y As double, _
    ByRef below As long, _
    ByRef above As long, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08aec Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef fr As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08afc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByRef l As long, _
    ByRef x As double, _
    ByVal lx As long, _
    ByRef h As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08agc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal median As double, _
    ByVal tail As Nag_TailProbability, _
    ByVal zeros As Nag_IncSignZeros, _
    ByRef w As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef non_zero As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08amc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n1 As long, _
    ByRef x As double, _
    ByVal n2 As long, _
    ByRef y As double, _
    ByVal tail As Nag_TailProbability, _
    ByVal exact As Nag_CompProb, _
    ByRef u As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08cbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal dist As Nag_Distributions, _
    ByRef par As double, _
    ByVal estima As Nag_ParaEstimates, _
    ByVal ntype As Nag_TestStatistics, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08cdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n1 As long, _
    ByRef x As double, _
    ByVal n2 As long, _
    ByRef y As double, _
    ByVal dtype As Nag_TestStatistics, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08cgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nclass As long, _
    ByRef ifreq As long, _
    ByRef ci As double, _
    ByVal dist As Nag_Distributions, _
    ByRef par As double, _
    ByVal npest As long, _
    ByRef prob As double, _
    ByRef chisq As double, _
    ByRef p As double, _
    ByRef ndf As long, _
    ByRef eval As double, _
    ByRef chisqi As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g08chc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub g08cjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef a2 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08ckc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef ybar As double, _
    ByRef yvar As double, _
    ByRef a2 As double, _
    ByRef aa2 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08clc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef ybar As double, _
    ByRef a2 As double, _
    ByRef aa2 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal max_run As long, _
    ByRef nruns As long, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08ebc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal max_count As long, _
    ByVal lag As long, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08ecc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal max_count As long, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08edc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal num_gaps As long, _
    ByVal max_gap As long, _
    ByVal lower As double, _
    ByVal upper As double, _
    ByVal length As double, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08rac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As long, _
    ByRef nv As long, _
    ByRef y As double, _
    ByVal p As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal idist As long, _
    ByVal nmax As long, _
    ByVal tol As double, _
    ByRef prvr As double, _
    ByVal pdparvar As long, _
    ByRef irank As long, _
    ByRef zin As double, _
    ByRef eta As double, _
    ByRef vapvec As double, _
    ByRef parest As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g08rbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As long, _
    ByRef nv As long, _
    ByRef y As double, _
    ByVal p As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef icen As long, _
    ByVal gamma As double, _
    ByVal nmax As long, _
    ByVal tol As double, _
    ByRef prvr As double, _
    ByVal pdprvr As long, _
    ByRef irank As long, _
    ByRef zin As double, _
    ByRef eta As double, _
    ByRef vapvec As double, _
    ByRef parest As double, _
    ByRef fail As NagError _
   )


' chapter g10

   Declare Ptrsafe Sub g10abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_SmoothFitType, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByVal rho As double, _
    ByRef yhat As double, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef res As double, _
    ByRef h As double, _
    ByRef comm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g10acc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_SmoothParamMethods, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByRef yhat As double, _
    ByRef coeff As double, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef res As double, _
    ByRef h As double, _
    ByRef crit As double, _
    ByRef rho As double, _
    ByVal u As double, _
    ByVal tol As double, _
    ByVal maxcal As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g10bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal wtype As Nag_WindowType, _
    ByRef window As double, _
    ByRef slo As double, _
    ByRef shi As double, _
    ByVal ns As long, _
    ByRef smooth As double, _
    ByRef t As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g10cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal smoother As Nag_Smooth_Type, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef smooth As double, _
    ByRef rough As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g10zac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByRef nord As long, _
    ByRef xord As double, _
    ByRef yord As double, _
    ByRef wwt As double, _
    ByRef rss As double, _
    ByRef fail As NagError _
   )


' chapter g11

   Declare Ptrsafe Sub g11aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal nrow As long, _
    ByVal ncol As long, _
    ByRef nobst As long, _
    ByVal tdt As long, _
    ByRef expt As double, _
    ByRef chist As double, _
    ByRef prob As double, _
    ByRef chi As double, _
    ByRef g As double, _
    ByRef df As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g11bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal stat As Nag_TableStats, _
    ByVal update As Nag_TableUpdate, _
    ByVal weight As Nag_Weightstype, _
    ByVal n As long, _
    ByVal nfac As long, _
    ByRef sf As long, _
    ByRef lfac As long, _
    ByRef factor As long, _
    ByVal tdf As long, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef table As double, _
    ByVal maxt As long, _
    ByRef ncells As long, _
    ByRef ndim As long, _
    ByRef idim As long, _
    ByRef count As long, _
    ByRef comm_ar As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g11bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal typ As Nag_TabulateVar, _
    ByVal n As long, _
    ByVal nfac As long, _
    ByRef sf As long, _
    ByRef lfac As long, _
    ByRef factor As long, _
    ByVal tdf As long, _
    ByVal percnt As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef table As double, _
    ByVal maxt As long, _
    ByRef ncells As long, _
    ByRef ndim As long, _
    ByRef idim As long, _
    ByRef count As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g11bcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal stat As Nag_TableStats, _
    ByRef table As double, _
    ByVal ncells As long, _
    ByVal ndim As long, _
    ByRef idim As long, _
    ByRef isdim As long, _
    ByRef sub_table As double, _
    ByVal maxst As long, _
    ByRef mcells As long, _
    ByRef mdim As long, _
    ByRef mlevel As long, _
    ByRef comm_ar As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g11cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByVal ns As long, _
    ByRef z As double, ByVal pdz As long, ByRef isz As long, _
    ByVal p As long, ByRef ic As long, ByRef isi As long, _
    ByRef dev As double, ByRef b As double, ByRef se As double, _
    ByRef sc As double, ByRef cov As double, ByRef nca As long, _
    ByRef nct As long, ByVal tol As double, ByVal maxit As long, _
    ByVal iprint As long, ByVal outfile As String, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g11sac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As long, ByVal n As long, ByVal gprob As Nag_Boolean, _
    ByVal ns As long, ByRef x As Nag_Boolean, ByVal pdx As long, _
    ByRef irl As long, ByRef a As double, ByRef c As double, _
    ByVal iprint As long, ByVal outfile As String, ByVal cgetol As double, _
    ByVal maxit As long, ByVal chisqr As Nag_Boolean, ByRef niter As long, _
    ByRef alpha As double, ByRef pigam As double, ByRef cm As double, _
    ByVal pdcm As long, ByRef g As double, ByRef expp As double, _
    ByVal pde As long, ByRef obs As double, ByRef exf As double, _
    ByRef y As double, ByRef iob As long, ByRef rlogl As double, _
    ByRef chi As double, ByRef idf As long, ByRef siglev As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g11sbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As long, _
    ByVal n As long, _
    ByRef ns As long, _
    ByRef x As Nag_Boolean, _
    ByVal pdx As long, _
    ByRef irl As long, _
    ByRef fail As NagError _
   )


' chapter g12

   Declare Ptrsafe Sub g12aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef t As double, _
    ByRef ic As long, _
    ByRef freq As long, _
    ByRef nd As long, _
    ByRef tp As double, _
    ByRef p As double, _
    ByRef psig As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g12abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef t As double, _
    ByRef ic As long, _
    ByRef grp As long, _
    ByVal ngrp As long, _
    ByRef ifreq As long, _
    ByRef wt As double, _
    ByRef ts As double, _
    ByRef df As long, _
    ByRef p As double, _
    ByRef obsd As double, _
    ByRef expt As double, _
    ByRef nd As long, _
    ByRef di As long, _
    ByRef ni As long, _
    ByVal ldn As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g12bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal m As long, ByVal ns As long, _
    ByRef z As double, ByVal tdz As long, ByRef sz As long, _
    ByVal ip As long, ByRef t As double, ByRef ic As long, _
    ByRef omega As double, ByRef isi As long, ByRef dev As double, _
    ByRef b As double, ByRef se As double, ByRef sc As double, _
    ByRef cov As double, ByRef res As double, ByRef nd As long, _
    ByRef tp As double, ByRef sur As double, ByVal tdsur As long, _
    ByVal ndmax As long, ByVal tol As double, ByVal max_iter As long, _
    ByVal iprint As long, ByVal outfile As String, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g12zac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByVal ns As long, _
    ByRef z As double, ByVal pdz As long, ByRef isz As long, _
    ByVal ip As long, ByRef t As double, ByRef ic As long, _
    ByRef isi As long, ByRef num As long, ByRef ixs As long, _
    ByRef nxs As long, ByRef x As double, ByVal mxn As long, _
    ByRef id As long, ByRef nd As long, ByRef tp As double, _
    ByRef irs As long, ByRef fail As NagError _
   )


' chapter g13

   Declare Ptrsafe Sub g13aac Lib "CLW6I26DE_nag.dll" ( _
    ByRef x As double, _
    ByVal nx As long, _
    ByVal d As long, _
    ByVal ds As long, _
    ByVal s As long, _
    ByRef xd As double, _
    ByRef nxd As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13abc Lib "CLW6I26DE_nag.dll" ( _
    ByRef x As double, _
    ByVal nx As long, _
    ByVal nk As long, _
    ByRef mean As double, _
    ByRef var As double, _
    ByRef r As double, _
    ByRef stat As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13acc Lib "CLW6I26DE_nag.dll" ( _
    ByRef r As double, _
    ByVal nk As long, _
    ByVal nl As long, _
    ByRef p As double, _
    ByRef v As double, _
    ByRef ar As double, _
    ByRef nvl As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13amc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As long, _
    ByRef param As double, _
    ByVal n As long, _
    ByRef y As double, _
    ByVal k As long, _
    ByRef init As double, _
    ByVal nf As long, _
    ByRef fv As double, _
    ByRef fse As double, _
    ByRef yhat As double, _
    ByRef res As double, _
    ByRef dv As double, _
    ByRef ad As double, _
    ByRef r As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13asc Lib "CLW6I26DE_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal n As long, _
    ByRef v As double, _
    ByVal m As long, _
    ByRef par As double, _
    ByVal narma As long, _
    ByRef r As double, _
    ByRef rc As double, _
    ByVal tdrc As long, _
    ByRef chi As double, _
    ByRef df As long, _
    ByRef siglev As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13auc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef z As double, _
    ByVal m As long, _
    ByVal rs As Nag_RangeStat, _
    ByRef y As double, _
    ByRef mean As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function g13awc Lib "CLW6I26DE_nag.dll" ( _
    ByVal typ As Nag_TS_URTestType, _
    ByVal p As long, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub g13bac Lib "CLW6I26DE_nag.dll" ( _
    ByRef y As double, _
    ByVal ny As long, _
    ByRef arimaf As Nag_ArimaOrder, _
    ByRef arimav As Nag_ArimaOrder, _
    ByRef par As double, _
    ByVal npar As long, _
    ByVal cy As double, _
    ByRef b As double, _
    ByVal nb As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bbc Lib "CLW6I26DE_nag.dll" ( _
    ByRef y As double, _
    ByVal ny As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef arimas As Nag_ArimaOrder, _
    ByRef par As double, _
    ByVal npar As long, _
    ByVal cy As double, _
    ByRef b As double, _
    ByVal nb As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bcc Lib "CLW6I26DE_nag.dll" ( _
    ByRef x As double, _
    ByRef y As double, _
    ByVal nxy As long, _
    ByVal nl As long, _
    ByRef s As double, _
    ByRef r0 As double, _
    ByRef r As double, _
    ByRef stat As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal r0 As double, _
    ByRef r As double, _
    ByVal nl As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByVal s As double, _
    ByRef wds As double, _
    ByRef isf As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bec Lib "CLW6I26DE_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef para As double, _
    ByVal npara As long, _
    ByVal nxxy As long, _
    ByRef xxy As double, _
    ByVal tdxxy As long, _
    ByRef sd As double, _
    ByRef rss As double, _
    ByRef objf As double, _
    ByRef df As double, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bgc Lib "CLW6I26DE_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nser As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef para As double, _
    ByVal npara As long, _
    ByVal nnv As long, _
    ByRef xxyn As double, _
    ByVal tdxxyn As long, _
    ByVal kzef As long, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bjc Lib "CLW6I26DE_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef para As double, _
    ByVal npara As long, _
    ByVal nev As long, _
    ByVal nfv As long, _
    ByRef xxy As double, _
    ByVal tdxxy As long, _
    ByRef rmsxy As double, _
    ByRef mrx As long, _
    ByVal tdmrx As long, _
    ByRef parx As double, _
    ByVal ldparx As long, _
    ByVal tdparx As long, _
    ByRef fva As double, _
    ByRef fsd As double, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bxc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ops As Nag_G13_Opt _
   )


   Declare Ptrsafe Sub g13byc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nseries As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13bzc Lib "CLW6I26DE_nag.dll" ( _
    ByRef transfv As Nag_TransfOrder _
   )


   Declare Ptrsafe Sub g13cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal nx As long, _
    ByVal mtx As long, _
    ByVal px As double, _
    ByVal iw As long, _
    ByVal mw As long, _
    ByVal ic As long, _
    ByVal nc As long, _
    ByRef c As double, _
    ByVal kc As long, _
    ByVal l As long, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    ByVal nxg As long, _
    ByRef xg As double, _
    ByRef ng As long, _
    ByRef stats As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13cbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nx As long, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal px As double, _
    ByVal mw As long, _
    ByVal pw As double, _
    ByVal l As long, _
    ByVal kc As long, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    ByRef x As double, _
    ByRef gptr As longPtr, _
    ByRef ng As long, _
    ByRef stats As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ccc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nxy As long, _
    ByVal mtxy_correction As NagMeanOrTrend, _
    ByVal pxy As double, _
    ByVal iw As long, _
    ByVal mw As long, _
    ByVal ish As long, _
    ByVal ic As long, _
    ByVal nc As long, _
    ByRef cxy As double, _
    ByRef cyx As double, _
    ByVal kc As long, _
    ByVal l As long, _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef g As Complex, _
    ByRef ng As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13cdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nxy As long, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal pxy As double, _
    ByVal mw As long, _
    ByVal s As long, _
    ByVal pw As double, _
    ByVal l As long, _
    ByVal kc As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef g As Complex, _
    ByRef ng As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13cec Lib "CLW6I26DE_nag.dll" ( _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef xyg As Complex, _
    ByVal ng As long, _
    ByRef stats As double, _
    ByRef ca As double, _
    ByRef calw As double, _
    ByRef caup As double, _
    ByRef t As double, _
    ByRef sc As double, _
    ByRef sclw As double, _
    ByRef scup As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13cfc Lib "CLW6I26DE_nag.dll" ( _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef xyg As Complex, _
    ByVal ng As long, _
    ByRef stats As double, _
    ByRef gn As double, _
    ByRef gnlw As double, _
    ByRef gnup As double, _
    ByRef ph As double, _
    ByRef phlw As double, _
    ByRef phup As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13cgc Lib "CLW6I26DE_nag.dll" ( _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef xyg As Complex, _
    ByVal ng As long, _
    ByRef stats As double, _
    ByVal l As long, _
    ByVal n As long, _
    ByRef er As double, _
    ByRef erlw As double, _
    ByRef erup As double, _
    ByRef rf As double, _
    ByRef rfse As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dbc Lib "CLW6I26DE_nag.dll" ( _
    ByRef c0 As double, _
    ByRef c As double, _
    ByVal ns As long, _
    ByVal nl As long, _
    ByVal nk As long, _
    ByRef p As double, _
    ByRef v0 As double, _
    ByRef v As double, _
    ByRef d As double, _
    ByRef db As double, _
    ByRef w As double, _
    ByRef wb As double, _
    ByRef nvp As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ddc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, ByVal n As long, ByVal ip As long, _
    ByVal iq As long, ByVal mean As Nag_IncludeMean, ByRef par As double, _
    ByVal npar As long, ByRef qq As double, ByVal kmax As long, _
    ByRef w As double, ByRef parhld As Nag_Boolean, ByVal exact As Nag_Boolean, _
    ByVal iprint As long, ByVal cgetol As double, ByVal maxcal As long, _
    ByVal ishow As long, ByVal outfile As String, ByRef niter As long, _
    ByRef rlogl As double, ByRef v As double, ByRef g As double, _
    ByRef cm As double, ByVal pdcm As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13djc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, ByVal n As long, ByRef z As double, _
    ByVal kmax As long, ByRef tr As long, ByRef id As long, _
    ByRef delta As double, ByVal ip As long, ByVal iq As long, _
    ByVal mean As Nag_IncludeMean, ByRef par As double, ByVal lpar As long, _
    ByRef qq As double, ByRef v As double, ByVal lmax As long, _
    ByRef predz As double, ByRef sefz As double, ByRef dnref As double, _
    ByVal lref As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal lmax As long, _
    ByVal m As long, _
    ByRef mlastptr As longPtr, _
    ByRef z As double, _
    ByVal kmax As long, _
    ByRef dnref As double, _
    ByVal lref As long, _
    ByRef v As double, _
    ByRef predz As double, _
    ByRef sefz As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByRef z As double, _
    ByRef tr As long, _
    ByRef id As long, _
    ByRef delta As double, _
    ByRef w As double, _
    ByRef nd As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal matrix As Nag_CovOrCorr, _
    ByVal k As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef w As double, _
    ByRef wmean As double, _
    ByRef r0 As double, _
    ByRef r As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dnc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef r0 As double, _
    ByRef r As double, _
    ByRef maxlag As long, _
    ByRef parlag As double, _
    ByRef x As double, _
    ByRef pvalue As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dpc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByRef z As double, _
    ByVal m As long, _
    ByRef maxlag As long, _
    ByRef parlag As double, _
    ByRef se As double, _
    ByRef qq As double, _
    ByRef x As double, _
    ByRef pvalue As double, _
    ByRef loglhd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dsc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, ByVal n As long, ByRef v As double, _
    ByVal kmax As long, ByVal ip As long, ByVal iq As long, _
    ByVal m As long, ByRef par As double, ByRef parhld As Nag_Boolean, _
    ByRef qq As double, ByVal ishow As long, ByVal outfile As String, _
    ByRef r0 As double, ByRef r As double, ByRef rcm As double, _
    ByVal pdrcm As long, ByRef chi As double, ByRef idf As long, _
    ByRef siglev As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13dxc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal ip As long, _
    ByRef par As double, _
    ByRef rr As double, _
    ByRef ri As double, _
    ByRef rmod As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByRef s As double, ByVal tds As long, ByRef a As double, _
    ByVal tda As long, ByRef b As double, ByVal tdb As long, _
    ByRef q As double, ByVal tdq As long, ByRef c As double, _
    ByVal tdc As long, ByRef r As double, ByVal tdr As long, _
    ByRef k As double, ByVal tdk As long, ByRef h As double, _
    ByVal tdh As long, ByVal tol As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ebc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByRef s As double, ByVal tds As long, ByRef a As double, _
    ByVal tda As long, ByRef b As double, ByVal tdb As long, _
    ByRef q As double, ByVal tdq As long, ByRef c As double, _
    ByVal tdc As long, ByRef r As double, ByVal tdr As long, _
    ByRef k As double, ByVal tdk As long, ByRef h As double, _
    ByVal tdh As long, ByVal tol As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ecc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByVal inp_ab As Nag_ab_input, ByRef t As double, ByVal tdt As long, _
    ByRef ainv As double, ByVal tda As long, ByRef b As double, _
    ByVal tdb As long, ByRef rinv As double, ByVal tdr As long, _
    ByRef c As double, ByVal tdc As long, ByRef qinv As double, _
    ByVal tdq As long, ByRef x As double, ByRef rinvy As double, _
    ByRef z As double, ByVal tol As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13edc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByRef t As double, ByVal tdt As long, ByRef ainv As double, _
    ByVal tda As long, ByRef ainvb As double, ByVal tdai As long, _
    ByRef rinv As double, ByVal tdr As long, ByRef c As double, _
    ByVal tdc As long, ByRef qinv As double, ByVal tdq As long, _
    ByRef x As double, ByRef rinvy As double, ByRef z As double, _
    ByVal tol As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ejc Lib "CLW6I26DE_nag.dll" ( _
    ByRef irevcm As long, ByVal mx As long, ByVal my As long, _
    ByRef y As double, ByRef lx As double, ByVal pdlx As long, _
    ByRef ly As double, ByVal pdly As long, ByRef x As double, _
    ByRef st As double, ByVal pdst As long, ByRef n As long, _
    ByRef xt As double, ByVal pdxt As long, ByRef fxt As double, _
    ByVal pdfxt As long, ByRef ropt As double, ByVal lropt As long, _
    ByRef icomm As long, ByVal licomm As long, ByRef rcomm As double, _
    ByVal lrcomm As long, ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g13ekc_f( _
'      ByVal mx As long, _
'      ByVal n As long, _
'      ByVal xt_rptr As longPtr, _
'      ByVal fxt_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub g13ekc_h( _
'      ByVal mx As long, _
'      ByVal my As long, _
'      ByVal n As long, _
'      ByVal yt_rptr As longPtr, _
'      ByVal hyt_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g13ekc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef y As double, _
    ByRef lx As double, _
    ByRef ly As double, _
    ByVal f As longPtr, _
    ByVal h As longPtr, _
    ByRef x As double, _
    ByRef st As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ewc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal p As long, _
    ByVal reduceto As Nag_ObserverForm, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef u As double, _
    ByVal tdu As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13exc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByVal reduceto As Nag_ControllerForm, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef b As double, _
    ByVal tdb As long, _
    ByRef u As double, _
    ByVal tdu As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13fac Lib "CLW6I26DE_nag.dll" ( _
    ByRef yt As double, ByRef x As double, ByVal tdx As long, _
    ByVal num As long, ByVal p As long, ByVal q As long, _
    ByVal nreg As long, ByVal mn As long, ByVal isym As long, _
    ByRef theta As double, ByRef se As double, ByRef sc As double, _
    ByRef covar As double, ByVal tdc As long, ByRef hp As double, _
    ByRef et As double, ByRef ht As double, ByRef lgf As double, _
    ByVal stat_opt As Nag_Garch_Stationary_Type, ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As long, _
    ByVal tol As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13fbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal num As long, _
    ByVal nt As long, _
    ByVal p As long, _
    ByVal q As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByRef fht As double, _
    ByRef ht As double, _
    ByRef et As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13fcc Lib "CLW6I26DE_nag.dll" ( _
    ByRef yt As double, ByRef x As double, ByVal tdx As long, _
    ByVal num As long, ByVal p As long, ByVal q As long, _
    ByVal nreg As long, ByVal mn As long, ByRef theta As double, _
    ByRef se As double, ByRef sc As double, ByRef covar As double, _
    ByVal tdc As long, ByRef hp As double, ByRef et As double, _
    ByRef ht As double, ByRef lgf As double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As long, ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13fdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal num As long, _
    ByVal nt As long, _
    ByVal p As long, _
    ByVal q As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByRef fht As double, _
    ByRef ht As double, _
    ByRef et As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13fec Lib "CLW6I26DE_nag.dll" ( _
    ByRef yt As double, ByRef x As double, ByVal tdx As long, _
    ByVal num As long, ByVal p As long, ByVal q As long, _
    ByVal nreg As long, ByVal mn As long, ByRef theta As double, _
    ByRef se As double, ByRef sc As double, ByRef covar As double, _
    ByVal tdc As long, ByRef hp As double, ByRef et As double, _
    ByRef ht As double, ByRef lgf As double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As long, ByVal tol As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ffc Lib "CLW6I26DE_nag.dll" ( _
    ByVal num As long, _
    ByVal nt As long, _
    ByVal p As long, _
    ByVal q As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByRef fht As double, _
    ByRef ht As double, _
    ByRef et As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13mec Lib "CLW6I26DE_nag.dll" ( _
    ByVal nb As long, _
    ByRef iema As double, _
    ByRef t As double, _
    ByVal tau As double, _
    ByVal m As long, _
    ByRef sinit As double, _
    ByRef inter As Nag_TS_Interpolation, _
    ByRef pn As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13mfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal nb As long, _
    ByRef z As double, _
    ByRef iema As double, _
    ByVal pdiema As long, _
    ByRef t As double, _
    ByVal tau As double, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByRef sinit As double, _
    ByRef inter As Nag_TS_Interpolation, _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As double, _
    ByRef x As double, _
    ByRef pn As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13mgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nb As long, _
    ByRef ma As double, _
    ByRef t As double, _
    ByVal tau As double, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByRef sinit As double, _
    ByRef inter As Nag_TS_Interpolation, _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As double, _
    ByRef pn As long, _
    ByRef wma As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13nac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As long, _
    ByRef y As double, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByRef param As double, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef sparam As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g13nbc_costfn( _
'      ByVal ts As long, _
'      ByVal nr As long, _
'      ByVal r_iptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g13nbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByVal k As double, _
    ByVal costfn As longPtr, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13ndc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As long, _
    ByRef y As double, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByRef param As double, _
    ByVal mdepth As long, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef sparam As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub g13nec_chgpfn( _
'      ByVal side As Nag_TS_SegSide, _
'      ByVal u As long, _
'      ByVal w As long, _
'      ByVal minss As long, _
'      ByRef v As long, _
'      ByVal cost_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub g13nec Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByVal mdepth As long, _
    ByVal chgpfn As longPtr, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub g13xzc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ops As Nag_G13_Opt _
   )


