

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter a00
' chapter a00

   Declare Ptrsafe Sub nag_implementation_details Lib "CLW6I26DE_nag.dll" Alias "a00aac" ( _
   )

   Declare Ptrsafe Function nag_licence_query Lib "CLW6I26DE_nag.dll" Alias "a00acc" ( _
   ) As long

   Declare Ptrsafe Sub nag_implementation_separated_details Lib "CLW6I26DE_nag.dll" Alias "a00adc" ( _
    ByVal impl As String, _
    ByVal prec As String, _
    ByVal pcode As String, _
    ByVal mkmaj As String, _
    ByVal mkmin As String, _
    ByVal hdware As String, _
    ByVal opsys As String, _
    ByVal ccomp As String, _
    ByVal fcomp As String, _
    ByVal vend As String, _
    ByRef licval As Nag_Boolean _
   )


' chapter a02
   Declare Ptrsafe Function nag_complex Lib "CLW6I26DE_nag.dll" Alias "a02bac" ( _
    ByVal x As double, _
    ByVal y As double _
   ) as Complex

   Declare Ptrsafe Function nag_complex_real Lib "CLW6I26DE_nag.dll" Alias "a02bbc" ( _
    ByRef z As Complex _
   ) As double

   Declare Ptrsafe Function nag_complex_imag Lib "CLW6I26DE_nag.dll" Alias "a02bcc" ( _
    ByRef z As Complex _
   ) As double

   Declare Ptrsafe Function nag_complex_add Lib "CLW6I26DE_nag.dll" Alias "a02cac" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_subtract Lib "CLW6I26DE_nag.dll" Alias "a02cbc" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_multiply Lib "CLW6I26DE_nag.dll" Alias "a02ccc" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_divide Lib "CLW6I26DE_nag.dll" Alias "a02cdc" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_negate Lib "CLW6I26DE_nag.dll" Alias "a02cec" ( _
    ByRef z As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_conjg Lib "CLW6I26DE_nag.dll" Alias "a02cfc" ( _
    ByRef z As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_equal Lib "CLW6I26DE_nag.dll" Alias "a02cgc" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) As long

   Declare Ptrsafe Function nag_complex_not_equal Lib "CLW6I26DE_nag.dll" Alias "a02chc" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) As long

   Declare Ptrsafe Function nag_complex_arg Lib "CLW6I26DE_nag.dll" Alias "a02dac" ( _
    ByRef z As Complex _
   ) As double

   Declare Ptrsafe Function nag_complex_abs Lib "CLW6I26DE_nag.dll" Alias "a02dbc" ( _
    ByRef z As Complex _
   ) As double

   Declare Ptrsafe Function nag_complex_sqrt Lib "CLW6I26DE_nag.dll" Alias "a02dcc" ( _
    ByRef z As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_i_power Lib "CLW6I26DE_nag.dll" Alias "a02ddc" ( _
    ByRef z As Complex, _
    ByVal i As long _
   ) as Complex

   Declare Ptrsafe Function nag_complex_r_power Lib "CLW6I26DE_nag.dll" Alias "a02dec" ( _
    ByRef z As Complex, _
    ByVal x As double _
   ) as Complex

   Declare Ptrsafe Function nag_complex_c_power Lib "CLW6I26DE_nag.dll" Alias "a02dfc" ( _
    ByRef v As Complex, _
    ByRef w As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_log Lib "CLW6I26DE_nag.dll" Alias "a02dgc" ( _
    ByRef z As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_exp Lib "CLW6I26DE_nag.dll" Alias "a02dhc" ( _
    ByRef v As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_sin Lib "CLW6I26DE_nag.dll" Alias "a02djc" ( _
    ByRef z As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_cos Lib "CLW6I26DE_nag.dll" Alias "a02dkc" ( _
    ByRef z As Complex _
   ) as Complex

   Declare Ptrsafe Function nag_complex_tan Lib "CLW6I26DE_nag.dll" Alias "a02dlc" ( _
    ByRef z As Complex _
   ) as Complex

