

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter h
' skeleton code for callback function
'  Sub nag_ip_bb_qphess( _
'      ByVal n As long, _
'      ByVal jthcol As long, _
'      ByVal h_rptr As longPtr, _
'      ByVal tdh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_ip_bb Lib "CLW6I26DE_nag.dll" Alias "h02bbc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef intvar As Nag_Boolean, _
    ByRef cvec As double, _
    ByRef h As double, _
    ByVal tdh As long, _
    ByVal qphess As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_H02_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_ip_mps_read Lib "CLW6I26DE_nag.dll" Alias "h02buc" ( _
    ByVal mps_file As String, _
    ByVal minimize As Nag_Boolean, _
    ByRef n As long, _
    ByRef m As long, _
    ByRef aptr As longPtr, _
    ByRef blptr As longPtr, _
    ByRef buptr As longPtr, _
    ByRef intvarptr As longPtr, _
    ByRef cvecptr As longPtr, _
    ByRef xptr As longPtr, _
    ByRef ops As Nag_H02_Opt, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_ip_mps_free Lib "CLW6I26DE_nag.dll" Alias "h02bvc" ( _
    ByRef aptr As longPtr, _
    ByRef blptr As longPtr, _
    ByRef buptr As longPtr, _
    ByRef intvarptr As longPtr, _
    ByRef cvecptr As longPtr, _
    ByRef xptr As longPtr _
   )

' skeleton code for callback function
'  Sub nag_mip_sqp_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal varcon_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_mip_sqp_objfun( _
'      ByRef mode As long, _
'      ByVal n As long, _
'      ByVal varcon_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByRef objmip As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_mip_sqp Lib "CLW6I26DE_nag.dll" Alias "h02dac" ( _
    ByVal n As long, ByVal nclin As long, ByVal ncnln As long, _
    ByRef a As double, ByVal pda As long, ByRef d As double, _
    ByRef ax As double, ByRef bl As double, ByRef bu As double, _
    ByRef varcon As long, ByRef x As double, ByVal confun As longPtr, _
    ByRef c As double, ByRef cjac As double, ByVal objfun As longPtr, _
    ByRef objgrd As double, ByVal maxit As long, ByVal acc As double, _
    ByRef objmip As double, ByRef iopts As long, ByRef opts As double, ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_ip_init Lib "CLW6I26DE_nag.dll" Alias "h02xxc" ( _
    ByRef ops As Nag_H02_Opt _
   )

   Declare Ptrsafe Sub nag_ip_read Lib "CLW6I26DE_nag.dll" Alias "h02xyc" ( _
    ByVal nm As String, _
    ByVal opt_file As String, _
    ByRef ops As Nag_H02_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_ip_free Lib "CLW6I26DE_nag.dll" Alias "h02xzc" ( _
    ByRef ops As Nag_H02_Opt, _
    ByVal p_name As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mip_opt_set Lib "CLW6I26DE_nag.dll" Alias "h02zkc" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mip_opt_get Lib "CLW6I26DE_nag.dll" Alias "h02zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_transport Lib "CLW6I26DE_nag.dll" Alias "h03abc" ( _
    ByRef cost As double, _
    ByVal tdcost As long, _
    ByRef avail As double, _
    ByVal navail As long, _
    ByRef req As double, _
    ByVal nreq As long, _
    ByVal maxit As long, _
    ByRef numit As long, _
    ByRef optq As double, _
    ByRef source As long, _
    ByRef dest As long, _
    ByRef optcost As double, _
    ByRef unitcost As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mip_tsp_simann Lib "CLW6I26DE_nag.dll" Alias "h03bbc" ( _
    ByVal nc As long, _
    ByRef dm As double, _
    ByVal bound As double, _
    ByVal targc As double, _
    ByRef path As long, _
    ByRef cost As double, _
    ByRef tmode As long, _
    ByRef alg_stats As double, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_best_subset_given_size_revcomm Lib "CLW6I26DE_nag.dll" Alias "h05aac" ( _
    ByRef irevcm As long, ByVal mincr As long, ByVal m As long, _
    ByVal ip As long, ByVal nbest As long, ByRef drop As long, _
    ByRef lz As long, ByRef z As long, ByRef la As long, _
    ByRef a As long, ByRef bscore As double, ByRef bz As long, _
    ByVal mincnt As long, ByVal gamma As double, ByRef acc As double, _
    ByRef icomm As long, ByVal licomm As long, ByRef rcomm As double, _
    ByVal lrcomm As long, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_best_subset_given_size_f( _
'      ByVal m As long, _
'      ByVal drop As long, _
'      ByVal lz As long, _
'      ByVal z_iptr As longPtr, _
'      ByVal la As long, _
'      ByVal a_iptr As longPtr, _
'      ByVal score_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_best_subset_given_size Lib "CLW6I26DE_nag.dll" Alias "h05abc" ( _
    ByVal mincr As long, _
    ByVal m As long, _
    ByVal ip As long, _
    ByVal nbest As long, _
    ByRef la As long, _
    ByRef bscore As double, _
    ByRef bz As long, _
    ByVal f As longPtr, _
    ByVal mincnt As long, _
    ByVal gamma As double, _
    ByRef acc As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

